



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JavaScript：exec()方法的用法及说明</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JavaScript：exec()方法的用法及说明</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 17:30:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>最近在看某知名js框架的源码，突然间发现自己对exec()方法竟然不太理解，然后就仔细的分析了一下这个方法</p>
<p>下面贴个exec()方法使用的代码出来</p>
<div>
<pre class="prettyprint linenums">rquickExpr = /^(?:\s*(&lt;[\w\W]+&gt;)[^&gt;]*|#([\w-]*))$/;<br />
match = rquickExpr.exec( selector );</pre>
</div>
<hr />
<p>exec() 方法就是用来检索字符串中正则表达式的匹配，如果匹配到了那么就返回一个存放有结果的数组，如果没有匹配到就返回一个null</p>
<p>(个人感觉这个方法和php里面的preg_match特别像啊~O(&cap;_&cap;)O哈哈~)</p>
<p>exec() 方法使用起来比test方法和String对象的match方法要复杂的多</p>
<blockquote><p>在这里说一下test方法和String对象的match方法</p>
<p>test()用于检测一个字符串是否匹配某个模式，也是一个正则匹配的方法，但是test()方法只会返回有没有匹配到规定的字符串，匹配到了就返回true。没有那么就返回false。</p>
<p>match()方法可在字符串内检索指定的值，或找到一个或多个正则表达式的匹配。</p>
<p>match和test的区别在于它可以直接检测字符串中是不是含有某个值，而不需使用正则表达式，第二个区别就是match函数可以进行一次或多次模式匹配，将匹配结果按照一个数组进行返回。(使用单次匹配还是多次匹配这取决于在匹配模式中是否含有g,我自己感觉没有g的就相当于php里面的preg_match函数，有的就相当于preg_match_all函数，哈哈)</p></blockquote>
<p>exec方法返回的数组的第 0 个元素是与正则表达式相匹配的文本</p>
<p>　　第 1 个元素是与 RegExpObject 的第 1 个子表达式相匹配的文本（如果有的话）</p>
<p>　　第 2 个元素是与 RegExpObject 的第 2 个子表达式相匹配的文本（如果有的话）</p>
<p>　　...</p>
<p>　　以此类推。</p>
<p>除了数组元素和 length 属性之外，exec() 方法还返回两个属性。</p>
<p>　　index 属性声明的是匹配文本的第一个字符的位置。</p>
<p>　　input 属性则存放的是被检索的字符串 string。</p>
<p>我们可以看得出，在调用非全局的 RegExp 对象的 exec() 方法时，返回的数组与调用方法 String.match() 返回的数组是相同的。</p>
<p>但是，当 RegExpObject 是一个全局正则表达式时，exec() 的行为就稍微复杂一些。</p>
<p>它会在 RegExpObject 的 lastIndex 属性指定的字符处开始检索字符串 string。</p>
<p>当 exec() 找到了与表达式相匹配的文本时，在匹配后，它将把 RegExpObject 的 lastIndex 属性设置为匹配文本的最后一个字符的下一个位置。</p>
<blockquote><p>lastIndex属性的意思就是当前匹配的字符串的最后一个字符的位置，比如说要在"abcdefg"中匹配"bcd",那么第一次匹配完成后的lastIndex就是4~</p></blockquote>
<p>这就是说，你可以通过反复调用 exec() 方法来遍历字符串中的所有匹配文本。</p>
<p>当 exec() 再也找不到匹配的文本时，它将返回 null，并把 lastIndex 属性重置为 0。</p>
<p>需要注意的是，如果在一个字符串中完成了一次模式匹配之后要开始检索新的字符串，就必须手动地把 lastIndex 属性重置为 0。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o13glq.html">Security3&colon; Schema 和 Permission</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ez54q.html">xcode6 使用pch出错解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4kjo09.html">tab使用 TabActivity TabHost Tabspec常用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwyjyr8.html">理解CSS3 transform中的Matrix&lpar;矩阵&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4v2jjq.html">监听调试web service的好工具TCPMon</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zv7559.html">mac下的ssh自动登陆</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmod569.html">ftp下载显示进度</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w3rgoq.html">第2章 数字之魅&mdash;&mdash;斐波那契（Fibonacci）数列</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x77pe8.html">postgresql 行转列，拼接字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxw7m8.html">『重构--改善既有代码的设计』读书笔记----Inline Temp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv40zyq.html">Java并发编程之ConcurrentHashMap</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zd6ke9.html">Linux系统7个运行级别&lpar;runlevel&rpar;&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z57je9.html">【爆料】-《昆士兰大学毕业证书》Queensland一模一样原件</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p1kjv8.html">&lbrack;物理学与PDEs&rsqb;第1章习题3 常场强下电势的定解问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy2olgq.html">Vue学习目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll2p66q.html">mysql 案例~select引起的性能问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdme7j9.html">特征点方法 - Harris和SURF的手工实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jx2req.html">ZUFE2480&colon; 神奇的序列                                                                                            2017-05-12 16&colon;45             39人阅读              评论&lpar;0&rpar;              收藏</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpev249.html">javascript&mdash;&mdash;select 标签的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pmrxeq.html">php 获取自己的公网IP</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2wmzlwq.html">erlang&colon; Programming Rules and Conventions。</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o7ejj9.html">JavaScript 跨域：谈谈跨域之 JSONP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvzx1jq.html">基于jQuery 常用WEB控件收集</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wmrylq.html">hdu 4859 海岸线 最小割</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydrd7dq.html">javascript Arguments对象&mdash;&mdash;函数的实际参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ynz33q.html">iOS开发，hook系统Objective-C的函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnek1j8.html">c&num;高效的线程安全队列ConcurrentQueue&amp;lt&semi;T&amp;gt&semi;&lpar;上&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnede08.html">项目源码--Android美图秀秀源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0pm0wq.html">GCC 嵌入汇编代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w0km3q.html">关于解决 The processing instruction target matching &amp;quot&semi;&lbrack;xX&rsqb;&lbrack;mM&rsqb;&lbrack;lL&rsqb;&amp;quot&semi; is not allowed</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
